Module javafx.controls
Package javafx.scene.control

# Class RadioMenuItem

java.lang.Object
javafx.scene.control.MenuItem
javafx.scene.control.RadioMenuItem

All Implemented Interfaces:
  `Styleable`, `EventTarget`, `Toggle`

    public class RadioMenuItem
    extends MenuItem
    implements Toggle

A RadioMenuItem is a `MenuItem` that can be toggled (it uses the `Toggle` mixin). This means that RadioMenuItem has an API very similar in nature to other controls that use `Toggle`, such as `RadioButton` and `ToggleButton`. RadioMenuItem is specifically designed for use within a `Menu`, so refer to that class API documentation for more information on how to add a RadioMenuItem into it.

To create a simple, ungrouped RadioMenuItem, do the following:

    RadioMenuItem radioItem = new RadioMenuItem("radio text");
    radioItem.setSelected(false);
    radioItem.setOnAction(e -> System.out.println("radio toggled"));

The problem with the example above is that this offers no benefit over using a normal MenuItem. As already mentioned, the purpose of a RadioMenuItem is to offer multiple choices to the user, and only allow for one of these choices to be selected at any one time (i.e. the selection should be mutually exclusive). To achieve this, you can place zero or more RadioMenuItem's into groups. When in groups, only one RadioMenuItem at a time within that group can be selected. To put two RadioMenuItem instances into the same group, simply assign them both the same value for `toggleGroup`. For example:

    ToggleGroup toggleGroup = new ToggleGroup();

    RadioMenuItem radioItem1 = new RadioMenuItem("Option 1");
    radioItem1.setOnAction(e -> System.out.println("radio1 toggled"));
    radioItem1.setToggleGroup(toggleGroup);

    RadioMenuItem radioItem2 = new RadioMenuItem("Option 2");
    radioItem2.setOnAction(e -> System.out.println("radio2 toggled"));
    radioItem2.setToggleGroup(toggleGroup);

    Menu menu = new Menu("Selection");
    menu.getItems().addAll(radioItem1, radioItem2);
    MenuBar menuBar = new MenuBar(menu);

In this example, with both RadioMenuItem's assigned to the same `ToggleGroup`, only one item may be selected at any one time, and should the selection change, the ToggleGroup will take care of deselecting the previous item.

Since:
  JavaFX 2.0
See Also:
  `MenuItem`, `Menu`

- ## Property Summary

  ### Properties declared in class javafx.scene.control.MenuItem

  `accelerator, disable, graphic, id, mnemonicParsing, onAction, onMenuValidation, parentMenu, parentPopup, style, text, visible`

  ### Properties declared in interface javafx.scene.control.Toggle

  `selected, toggleGroup`

- ## Field Summary

  ### Fields declared in class javafx.scene.control.MenuItem

  `MENU_VALIDATION_EVENT`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `RadioMenuItem()` | Constructs a RadioMenuItem with no display text.
  `RadioMenuItem​(String text)` | Constructs a RadioMenuItem and sets the display text with the specified text.
  `RadioMenuItem​(String text, Node graphic)` | Constructs a RadioMenuItem and sets the display text with the specified text and sets the graphic `Node` to the given node.

- ## Method Summary

  ### Methods declared in class javafx.scene.control.MenuItem

  `acceleratorProperty, addEventHandler, disableProperty, fire, getAccelerator, getGraphic, getOnAction, getOnMenuValidation, getParentMenu, getParentPopup, getProperties, getPseudoClassStates, getStyleableParent, getText, getTypeSelector, getUserData, graphicProperty, idProperty, isDisable, isMnemonicParsing, isVisible, mnemonicParsingProperty, onActionProperty, onMenuValidationProperty, parentMenuProperty, parentPopupProperty, removeEventHandler, setAccelerator, setDisable, setGraphic, setId, setMnemonicParsing, setOnAction, setOnMenuValidation, setParentMenu, setParentPopup, setStyle, setText, setUserData, setVisible, styleProperty, textProperty, visibleProperty`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods declared in interface javafx.event.EventTarget

  `buildEventDispatchChain`

  ### Methods declared in interface javafx.css.Styleable

  `getCssMetaData, getId, getStyle, getStyleableNode, getStyleClass`

  ### Methods declared in interface javafx.scene.control.Toggle

  `getProperties, getToggleGroup, getUserData, isSelected, selectedProperty, setSelected, setToggleGroup, setUserData, toggleGroupProperty`

- ## Constructor Details

  - ### RadioMenuItem

    public RadioMenuItem()
    Constructs a RadioMenuItem with no display text.

  - ### RadioMenuItem

    public RadioMenuItem​(String text)
    Constructs a RadioMenuItem and sets the display text with the specified text.
    Parameters:
      `text` - the display text

  - ### RadioMenuItem

    public RadioMenuItem​(String text, Node graphic)
    Constructs a RadioMenuItem and sets the display text with the specified text and sets the graphic `Node` to the given node.
    Parameters:
      `text` - the display text
      `graphic` - the graphic node